function [model] = leastSquaresBias(X,y)

% Add bias variable
[n,d] = size(X);
X = [ones(n,1) X];

% Solve least squares problem (assumes X'*X is invertible)
w = (X'*X)\X'*y;

model.w = w;
model.predict = @predict;

end

function [yhat] = predict(model,Xhat)
[t,d] = size(Xhat);
Xhat = [ones(t,1) Xhat];
w = model.w;
yhat = sign(Xhat*w);
end